__gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc > Class Template Reference

`#include <binomial_heap_base_.hpp>`

Inheritance diagram for __gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >:
[legend]

## Public Types

typedef _Alloc | allocator_type
typedef Cmp_Fn | cmp_fn
typedef base_type::const_iterator | const_iterator
typedef __rebind_v::const_pointer | const_pointer
typedef __rebind_v::const_reference | const_reference
typedef _Alloc::difference_type | difference_type
typedef base_type::iterator | iterator
typedef base_type::point_const_iterator | point_const_iterator
typedef base_type::point_iterator | point_iterator
typedef __rebind_v::pointer | pointer
typedef __rebind_v::reference | reference
typedef _Alloc::size_type | size_type
typedef Value_Type | value_type

## Public Member Functions

iterator | begin ()
void | clear ()
bool | empty () const
iterator | end ()
void | erase (point_iterator)
template<typename Pred>
size_type | erase_if (Pred)
Cmp_Fn & | get_cmp_fn ()
void | join (binomial_heap_base< Value_Type, Cmp_Fn, _Alloc > &)
size_type | max_size () const
void | modify (point_iterator, const_reference)
void | pop ()
point_iterator | push (const_reference)
size_type | size () const
template<typename Pred>
void | split (Pred, binomial_heap_base< Value_Type, Cmp_Fn, _Alloc > &)
void | swap (left_child_next_sibling_heap< Value_Type, Cmp_Fn, _Alloc::size_type, _Alloc > &)
const_reference | top () const

## Protected Types

typedef base_type::node | node
typedef alloc_traits::allocator_type | node_allocator
typedef base_type::node_const_pointer | node_const_pointer
typedef _Alloc::size_type | node_metadata
typedef base_type::node_pointer | node_pointer
typedef std::pair< node_pointer, node_pointer > | node_pointer_pair

## Protected Member Functions

| binomial_heap_base (const binomial_heap_base< Value_Type, Cmp_Fn, _Alloc > &)
| binomial_heap_base (const Cmp_Fn &)
void | actual_erase_node (node_pointer)
void | bubble_to_top (node_pointer)
void | clear_imp (node_pointer)
template<typename It>
void | copy_from_range (It, It)
void | find_max ()
node_pointer | get_new_node_for_insert (const_reference)
node_pointer | prune (Pred)
void | swap (binomial_heap_base< Value_Type, Cmp_Fn, _Alloc > &)
void | swap_with_parent (node_pointer, node_pointer)
void | to_linked_list ()
void | value_swap (left_child_next_sibling_heap &)

## Static Protected Member Functions

static void | make_child_of (node_pointer, node_pointer)
static node_pointer | parent (node_pointer)

## Protected Attributes

node_pointer | m_p_max
node_pointer | m_p_root
size_type | m_size

## Detailed Description

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>
class __gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >

Base class for binomial heap.

Definition at line 77 of file binomial_heap_base_.hpp.

## Member Typedef Documentation

## allocator_type

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

typedef _Alloc __gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >::allocator_type

Definition at line 92 of file binomial_heap_base_.hpp.

## cmp_fn

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

typedef Cmp_Fn __gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >::cmp_fn

Definition at line 91 of file binomial_heap_base_.hpp.

## const_iterator

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

typedef base_type::const_iterator __gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >::const_iterator

Definition at line 103 of file binomial_heap_base_.hpp.

## const_pointer

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

typedef __rebind_v::const_pointer __gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >::const_pointer

Definition at line 97 of file binomial_heap_base_.hpp.

## const_reference

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

typedef __rebind_v::const_reference __gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >::const_reference

Definition at line 99 of file binomial_heap_base_.hpp.

## difference_type

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

typedef _Alloc::difference_type __gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >::difference_type

Definition at line 94 of file binomial_heap_base_.hpp.

## iterator

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

typedef base_type::iterator __gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >::iterator

Definition at line 104 of file binomial_heap_base_.hpp.

## node

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

typedef base_type::node __gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >::node

protected

Definition at line 85 of file binomial_heap_base_.hpp.

## node_allocator

typedef alloc_traits::allocator_type __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, _Alloc::size_type, _Alloc >::node_allocator

protected inherited

Definition at line 101 of file left_child_next_sibling_heap_.hpp.

## node_const_pointer

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

typedef base_type::node_const_pointer __gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >::node_const_pointer

protected

Definition at line 87 of file binomial_heap_base_.hpp.

## node_metadata

typedef _Alloc::size_type __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, _Alloc::size_type, _Alloc >::node_metadata

protected inherited

Definition at line 105 of file left_child_next_sibling_heap_.hpp.

## node_pointer

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

typedef base_type::node_pointer __gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >::node_pointer

protected

Definition at line 86 of file binomial_heap_base_.hpp.

## node_pointer_pair

typedef std::pair<node_pointer, node_pointer> __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, _Alloc::size_type, _Alloc >::node_pointer_pair

protected inherited

Definition at line 106 of file left_child_next_sibling_heap_.hpp.

## point_const_iterator

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

typedef base_type::point_const_iterator __gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >::point_const_iterator

Definition at line 101 of file binomial_heap_base_.hpp.

## point_iterator

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

typedef base_type::point_iterator __gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >::point_iterator

Definition at line 102 of file binomial_heap_base_.hpp.

## pointer

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

typedef __rebind_v::pointer __gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >::pointer

Definition at line 96 of file binomial_heap_base_.hpp.

## reference

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

typedef __rebind_v::reference __gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >::reference

Definition at line 98 of file binomial_heap_base_.hpp.

## size_type

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

typedef _Alloc::size_type __gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >::size_type

Definition at line 93 of file binomial_heap_base_.hpp.

## value_type

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

typedef Value_Type __gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >::value_type

Definition at line 90 of file binomial_heap_base_.hpp.

## Constructor & Destructor Documentation

## binomial_heap_base() [1/3]

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

__gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >::binomial_heap_base | ( |  | ) |

protected

Definition at line 56 of file binomial_heap_base_.hpp.

## binomial_heap_base() [2/3]

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

__gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >::binomial_heap_base | ( | const Cmp_Fn & | r_cmp_fn | ) |

protected

Definition at line 63 of file binomial_heap_base_.hpp.

## binomial_heap_base() [3/3]

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

__gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >::binomial_heap_base | ( | const binomial_heap_base< Value_Type, Cmp_Fn, _Alloc > & | other | ) |

protected

Definition at line 69 of file binomial_heap_base_.hpp.

## ~binomial_heap_base()

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

__gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >::~binomial_heap_base | ( |  | ) |

protected

Definition at line 86 of file binomial_heap_base_.hpp.

## Member Function Documentation

## actual_erase_node()

void __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, _Alloc::size_type, _Alloc >::actual_erase_node | ( | node_pointer | p_nd | ) |

inline protected inherited

Definition at line 205 of file left_child_next_sibling_heap_.hpp.

## begin()

left_child_next_sibling_heap< Value_Type, Cmp_Fn, _Alloc::size_type, _Alloc >::iterator __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, _Alloc::size_type, _Alloc >::begin | ( |  | ) |

inline inherited

Definition at line 166 of file left_child_next_sibling_heap_.hpp.

## bubble_to_top()

void __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, _Alloc::size_type, _Alloc >::bubble_to_top | ( | node_pointer | p_nd | ) |

protected inherited

Definition at line 202 of file left_child_next_sibling_heap_.hpp.

## clear()

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

void __gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >::clear | ( |  | ) |

inline

Definition at line 97 of file binomial_heap_base_.hpp.

## clear_imp()

void __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, _Alloc::size_type, _Alloc >::clear_imp | ( | node_pointer | p_nd | ) |

protected inherited

Definition at line 208 of file left_child_next_sibling_heap_.hpp.

## copy_from_range()

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>
template<typename It>

void __gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >::copy_from_range | ( | It | first_it,
|  | It | last_it )

protected

Definition at line 47 of file binomial_heap_base_.hpp.

## empty()

bool __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, _Alloc::size_type, _Alloc >::empty | ( |  | ) | const

inline nodiscard inherited

Definition at line 151 of file left_child_next_sibling_heap_.hpp.

## end()

left_child_next_sibling_heap< Value_Type, Cmp_Fn, _Alloc::size_type, _Alloc >::iterator __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, _Alloc::size_type, _Alloc >::end | ( |  | ) |

inline inherited

Definition at line 172 of file left_child_next_sibling_heap_.hpp.

## erase()

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

void __gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >::erase | ( | point_iterator | it | ) |

Definition at line 106 of file binomial_heap_base_.hpp.

## erase_if()

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>
template<typename Pred>

binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >::size_type __gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >::erase_if | ( | Pred | pred | ) |

Definition at line 122 of file binomial_heap_base_.hpp.

## find_max()

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

void __gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >::find_max | ( |  | ) |

inline protected

Definition at line 61 of file binomial_heap_base_.hpp.

## get_cmp_fn()

Cmp_Fn & __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, _Alloc::size_type, _Alloc >::get_cmp_fn | ( |  | ) |

inherited

Definition at line 160 of file left_child_next_sibling_heap_.hpp.

## get_new_node_for_insert()

left_child_next_sibling_heap< Value_Type, Cmp_Fn, _Alloc::size_type, _Alloc >::node_pointer __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, _Alloc::size_type, _Alloc >::get_new_node_for_insert | ( | const_reference | r_val | ) |

inline protected inherited

Definition at line 187 of file left_child_next_sibling_heap_.hpp.

## join()

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

void __gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >::join | ( | binomial_heap_base< Value_Type, Cmp_Fn, _Alloc > & | other | ) |

inline

Definition at line 108 of file binomial_heap_base_.hpp.

## make_child_of()

void __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, _Alloc::size_type, _Alloc >::make_child_of | ( | node_pointer | p_nd,
|  | node_pointer | p_new_parent )

inline static protected inherited

Definition at line 190 of file left_child_next_sibling_heap_.hpp.

## max_size()

left_child_next_sibling_heap< Value_Type, Cmp_Fn, _Alloc::size_type, _Alloc >::size_type __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, _Alloc::size_type, _Alloc >::max_size | ( |  | ) | const

inline inherited

Definition at line 157 of file left_child_next_sibling_heap_.hpp.

## modify()

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

void __gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >::modify | ( | point_iterator | it,
|  | const_reference | r_new_val )

Definition at line 146 of file binomial_heap_base_.hpp.

## parent()

left_child_next_sibling_heap< Value_Type, Cmp_Fn, _Alloc::size_type, _Alloc >::node_pointer __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, _Alloc::size_type, _Alloc >::parent | ( | node_pointer | p_nd | ) |

inline static protected inherited

Definition at line 196 of file left_child_next_sibling_heap_.hpp.

## pop()

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

void __gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >::pop | ( |  | ) |

Definition at line 46 of file binomial_heap_base_.hpp.

## prune()

left_child_next_sibling_heap< Value_Type, Cmp_Fn, _Alloc::size_type, _Alloc >::node_pointer __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, _Alloc::size_type, _Alloc >::prune | ( | Pred | pred | ) |

protected inherited

Definition at line 215 of file left_child_next_sibling_heap_.hpp.

## push()

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >::point_iterator __gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >::push | ( | const_reference | r_val | ) |

inline

Definition at line 46 of file binomial_heap_base_.hpp.

## size()

left_child_next_sibling_heap< Value_Type, Cmp_Fn, _Alloc::size_type, _Alloc >::size_type __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, _Alloc::size_type, _Alloc >::size | ( |  | ) | const

inline inherited

Definition at line 154 of file left_child_next_sibling_heap_.hpp.

## split()

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>
template<typename Pred>

void __gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >::split | ( | Pred | pred,
|  | binomial_heap_base< Value_Type, Cmp_Fn, _Alloc > & | other )

Definition at line 47 of file binomial_heap_base_.hpp.

## swap() [1/2]

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

void __gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >::swap | ( | binomial_heap_base< Value_Type, Cmp_Fn, _Alloc > & | other | ) |

protected

Definition at line 76 of file binomial_heap_base_.hpp.

## swap() [2/2]

void __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, _Alloc::size_type, _Alloc >::swap | ( | left_child_next_sibling_heap< Value_Type, Cmp_Fn, _Alloc::size_type, _Alloc > & | other | ) |

inherited

Definition at line 146 of file left_child_next_sibling_heap_.hpp.

## swap_with_parent()

void __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, _Alloc::size_type, _Alloc >::swap_with_parent | ( | node_pointer | p_nd,
|  | node_pointer | p_parent )

inline protected inherited

Definition at line 199 of file left_child_next_sibling_heap_.hpp.

## to_linked_list()

void __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, _Alloc::size_type, _Alloc >::to_linked_list | ( |  | ) |

protected inherited

Definition at line 211 of file left_child_next_sibling_heap_.hpp.

## top()

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >::const_reference __gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >::top | ( |  | ) | const

inline

Definition at line 46 of file binomial_heap_base_.hpp.

## value_swap()

void __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, _Alloc::size_type, _Alloc >::value_swap | ( | left_child_next_sibling_heap< Value_Type, Cmp_Fn, _Alloc::size_type, _Alloc > & | other | ) |

protected inherited

Definition at line 193 of file left_child_next_sibling_heap_.hpp.

## Member Data Documentation

## m_p_max

template<typename Value_Type, typename Cmp_Fn, typename _Alloc>

node_pointer __gnu_pbds::detail::binomial_heap_base< Value_Type, Cmp_Fn, _Alloc >::m_p_max

protected

Definition at line 186 of file binomial_heap_base_.hpp.

## m_p_root

node_pointer __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, _Alloc::size_type, _Alloc >::m_p_root

protected inherited

Definition at line 270 of file left_child_next_sibling_heap_.hpp.

## m_size

size_type __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, _Alloc::size_type, _Alloc >::m_size

protected inherited

Definition at line 271 of file left_child_next_sibling_heap_.hpp.

The documentation for this class was generated from the following file:

- binomial_heap_base_.hpp